{% extends 'base.html' %}
{% load static %}

{% block meta %}
<title>Forward Gravity Model</title>
<meta charset="utf-8">
<style type="text/css">
	body {
		font-size: 12px;
		background-color: #f0f0f0;
		overflow: hidden;
	}
</style>
{% endblock meta %}

{% block content %}

<script type="text/javascript" src="{% static 'js/ThreeCanvas.js' %}"></script>
<script type="text/javascript" src="{% static 'js/Cube.js' %}"></script>
<script type="text/javascript" src="{% static 'js/Plane.js' %}"></script>

<script src="{% static 'js/ga.js' %}"></script>
<div href="#" data-toggle="tooltip" title="Hooray!">
	<script type="text/javascript">
		// deklarasi variabel
		var container, interval,
		camera, scene, renderer,
		projector, plane, cube, linesMaterial,
		color = 0,colors = [ 0xDF1F1F, 0xDFAF1F, 0x80DF1F, 0x1FDF50, 0x1FDFDF, 0x1F4FDF, 0x7F1FDF, 0xDF1FAF, 0xEFEFEF, 0x303030 ],
		ray, brush, objectHovered, densities = [1,2,3,4,5,6,7,8,9,0], density = 0,
		mouse3D, isMouseDown = false, onMouseDownPosition, save_data,
		radious = 1600, theta = 45, onMouseDownTheta = 45, phi = 60, onMouseDownPhi = 60,
		isShiftDown = false, koordinat_x = 0, koordinat_y = 0, koordinat_z = 0,
		alf_code = ["a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z","A","B","C","D","E","F"],
		bin_code = ["00000","00001","00010","00011","00100","00101","00110","00111","01000","01001","01010","01011","01100","01101","01110","01111","10000","10001","10010","10011","10100","10101","10110","10111","11000","11001","11010","11011","11100","11101","11110","11111"];
		
		// penjalanan fungsi init dan render
		init();
		render();
	
		function init() {
	
			container = document.createElement( 'div' ); // membuat elemen html div
			document.body.appendChild( container ); // menambahkan elemen container ke dalam body page web
	
			var info = document.createElement( 'div' ); // membuat elemen html div dengan variable info
			info.style.position = 'absolute';
			info.style.top = '5px';
			info.style.width = '100%';
			info.style.textAlign = 'center';
			info.innerHTML = '<span style="color: #444; background-color: #fff; border-bottom: 1px solid #ddd; padding: 8px 10px; text-transform: uppercase;margin-top: 60px; display:inline-block"><strong>0 - 9</strong>: colors, <strong>click</strong>: add box, <strong>shift + click</strong>: remove box, <strong>drag</strong>: rotate | <button id="custom_box" onclick="custom_box_function();" target="_blank">custom box</button> <button id="process_function" onclick="save_data_function();" target="_blank">process</button> <a id="link" href="javascript:download();">Download</a> <a href="javascript:clear();">clear</a></span>';
			container.appendChild( info ); // menambahkan elemen html info kedalam container (container merupakan variable div)
	
			camera = new THREE.Camera( 40, window.innerWidth / window.innerHeight, 1, 10000 ); // membuat object dari camera pada file ThreeCanvas.js
			camera.position.x = radious * Math.sin( theta * Math.PI / 360 ) * Math.cos( phi * Math.PI / 360 ); // mengatur posisi tampilan web pada sumbu x
			camera.position.y = radious * Math.sin( phi * Math.PI / 360 ); // mengatur posisi tampilan web pada sumbu y
			camera.position.z = radious * Math.cos( theta * Math.PI / 360 ) * Math.cos( phi * Math.PI / 360 ); // mengatur posisi tampilan web pada sumbu x
			camera.target.position.y = 200;
	
			scene = new THREE.Scene(); // membuat object scene dari file ThreeCanvas.js
	
			// Grid
			// kalau mau ubah grid pengukuran, harus ubah yang line 64,64,72,76,84
	
			var geometry = new THREE.Geometry(); // membuat object geometry dari file ThreeCanvas.js
			geometry.vertices.push( new THREE.Vertex( new THREE.Vector3( - 2500, 0, 0 ) ) ); // menambahkan posisi titik sudut (vertices) pada geometri dengan vector 3D
			geometry.vertices.push( new THREE.Vertex( new THREE.Vector3( 2500, 0, 0 ) ) );
	
			linesMaterial = new THREE.LineColorMaterial( 0x000000, 0.2 ); // mengatur warna line
	
			for ( var i = 0; i <= 100; i ++ ) {
	
				var line = new THREE.Line( geometry, linesMaterial ); // membuat garis dari 2 titik sudut yang sebelumnya sudah dibuat
				line.position.z = ( i * 50 ) - 2500; // mengatur posisi garis baru
				scene.addObject( line ); // menyimpan garisnya kedalam scene
	
				var line = new THREE.Line( geometry, linesMaterial ); // membuat garis dari 2 titik sudut yang sebelumnya sudah dibuat
				line.position.x = ( i * 50 ) - 2500; // mengatur posisi garis baru
				line.rotation.y = 90 * Math.PI / 180; // merotasi garis dari sudut pandang sumbu y sebesar 90 derajat
				scene.addObject( line ); // menyimpan garisnya kedalam scene
	
			}
	
			projector = new THREE.Projector(); // membuat objek projector dari file ThreeCanvas.js
	
			plane = new THREE.Mesh( new Plane( 5000, 5000 ) ); // kita membuat mesh (polygon mesh) pada bidang seluas 1000x1000 (bidang x dan y)
			plane.rotation.x = - 90 * Math.PI / 180;
			scene.addObject( plane );
	
			cube = new Cube( 50, 50, 50 ); // membuat kubus berukuran 50x50x50 
	
			ray = new THREE.Ray( camera.position, null ); // digunakan untuk mengatur perspektif 3D ke layar 2D
	
			brush = new THREE.Mesh( cube, new THREE.MeshColorFillMaterial( colors[ color ], 0.4 ) ); // membuat mesh berupa kubus yang telah dibuat sebelumnya dan mewarnainya. brush ini digunakan sebagai painter kubus
			brush.position.y = 25; // mengatur posisi brush persegi (kalo bingung apa itu brush, coba buka paint)
			brush.overdraw = true; // baca kenapa overdraw penting https://developer.android.com/topic/performance/rendering/overdraw?hl=id 
			scene.addObject( brush ); // menyimpan brush kedalam scene
	
			onMouseDownPosition = new THREE.Vector2(); // membuat vector 2d dengan default x = 0, y = 0
	
			// Lights
	
			var ambientLight = new THREE.AmbientLight( 0x404040 ); // mengatur pencahayaan box dengan kode warna hex
			scene.addLight( ambientLight ); // menyimpan light ke dalam scene
	
			var directionalLight = new THREE.DirectionalLight( 0xffffff ); // mengatur pencahayaan box dengan kode warna hex 
			directionalLight.position.x = 1; // mengatur koordinat sumber cahaya x
			directionalLight.position.y = 1; // mengatur koordinat sumber cahaya y
			directionalLight.position.z = 0.75; // mengatur koordinat sumber cahaya z
			directionalLight.position.normalize(); // normalisasi vektor posisinya mmenjadi vektor satuan
			scene.addLight( directionalLight ); // menyimpan light ke dalam scene
	
			var directionalLight = new THREE.DirectionalLight( 0x808080 ); // mengatur pencahayaan box dengan kode warna hex 
			directionalLight.position.x = - 1; // mengatur koordinat sumber cahaya x
			directionalLight.position.y = 1; // mengatur koordinat sumber cahaya y
			directionalLight.position.z = - 0.75; // mengatur koordinat sumber cahaya z
			directionalLight.position.normalize(); // normalisasi vektor posisinya mmenjadi vektor satuan
			scene.addLight( directionalLight ); // menyimpan light ke dalam scene
			// normalisasi vektor menjadi vektor satuan digunakan untuk menunjukkan arah vektor cahaya dari titik pusat
			// hanya dibutuhkan vektor satuan karena sumber cahaya dianggap sangat jauh dan diteruskan hingga tak hingga sehingga hanya 
			// dibutuhkan vektor satuan untuk menunjukkan arah datangnya cahaya

			renderer = new THREE.CanvasRenderer(); // membuat variable untuk merender/membangun gambar dari model yang akan diatur nantinya
			renderer.setSize( window.innerWidth, window.innerHeight ); // mengatur ukuran sehingga sesuai dengan size window
	
			container.appendChild(renderer.domElement); // menabahkan elemen renderer.domElement yang merupakan canvas tempat renderer menggambar outputnya
	
			document.addEventListener( 'keydown', onDocumentKeyDown, false ); // menambahkan event saat user menggunakan keydown(saat tombol di keyboard ditekan ke bawah)
			document.addEventListener( 'keyup', onDocumentKeyUp, false ); // menambahkan event saat user menggunakan keyup (saat tombol di keyboard dilepas)
	
			document.addEventListener( 'mousemove', onDocumentMouseMove, false ); // menambahkan event saat user menggerakkan mouse
			document.addEventListener( 'mousedown', onDocumentMouseDown, false ); // menambahkan event saat user menekan tombol mouse
			document.addEventListener( 'mouseup', onDocumentMouseUp, false ); // menambahkan event saat user melepas tombol mouse
	
			document.addEventListener( 'mousewheel', onDocumentMouseWheel, false ); // menambahkan event saat user scroll mouse
	
			if ( window.location.pathname.length > 9 ) { // memeriksa apakah link document diawali dengan # atau tidak
				
				buildFromHash(); // memanggil fungsi buildFromHash()
	
			}
	
		}
	
		function onDocumentKeyDown( event ) {
	
			switch( event.keyCode ) { // switch saat tombol keyboard ditekan (setiap tombol memiliki keycode)
	
				case 49: setBrushColor( 0 ); density = 0; break; // mewarnai kubus saat nomor 0 ditekan
				case 50: setBrushColor( 1 ); density = 1; break; // mewarnai kubus saat nomor 1 ditekan
				case 51: setBrushColor( 2 ); density = 2; break; // mewarnai kubus saat nomor 2 ditekan
				case 52: setBrushColor( 3 ); density = 3; break; // mewarnai kubus saat nomor 3 ditekan
				case 53: setBrushColor( 4 ); density = 4; break; // mewarnai kubus saat nomor 4 ditekan
				case 54: setBrushColor( 5 ); density = 5; break; // mewarnai kubus saat nomor 5 ditekan
				case 55: setBrushColor( 6 ); density = 6; break; // mewarnai kubus saat nomor 6 ditekan
				case 56: setBrushColor( 7 ); density = 7; break; // mewarnai kubus saat nomor 7 ditekan
				case 57: setBrushColor( 8 ); density = 8; break; // mewarnai kubus saat nomor 8 ditekan
				case 48: setBrushColor( 9 ); density = 9; break; // mewarnai kubus saat nomor 9 ditekan
				case 70: alert("koordinatnya x :"+koordinat_x+" ,koordinat y :"+koordinat_y+" ,koordinat z :"+koordinat_z); break;

				case 16: isShiftDown = true; interact(); render(); break; // saat tombol shift ditekan maka akan menjalankan fungsi interact dan render
	
				case 37: offsetScene( - 1, 0 ); break; // saat tombol kiri ditekan, maka akan menggerakkan seluruh kubus ke kiri
				case 38: offsetScene( 0, - 1 ); break; // saat tombol atas ditekan, maka akan menggerakkan seluruh kubus ke atas
				case 39: offsetScene( 1, 0 ); break; // saat tombol kanan ditekan, maka akan menggerakkan seluruh kubus ke kanan
				case 40: offsetScene( 0, 1 ); break; // saat tombol bawah ditekan, maka akan menggerakkan seluruh kubus ke bawah
	
			}
	
		}
	
		function onDocumentKeyUp( event ) {
	
			switch( event.keyCode ) {
	
				case 16: isShiftDown = false; interact(); render(); break; // saat tombol shift dilepas maka akan menjalankan fungsi interact dan render
	
			}
	
		}
	
		function onDocumentMouseDown( event ) {
	
			event.preventDefault(); // digunakan untuk mematikan fungsi default sebelumnya apabila
			// kita melakukan event tertentu sehingga kita bisa mengisi fungsi saat event tersebut ditekan.
			// bisa juga untuk mencegah fungsi yang dikhawatirkan menyebabkan reload pada pages.
	
			isMouseDown = true; // mengubah isi boolean ismousedown menjadi true
	
			onMouseDownTheta = theta; // mengisi variable onMouseDownTheta dengan theta. theta disini akan berubah nilainya sesuai fungsi onDocumentMouseMove
			onMouseDownPhi = phi; // mengisi variable onMouseDownphi dengan phi. phi disini akan berubah nilainya sesuai fungsi onDocumentMouseMove
			onMouseDownPosition.x = event.clientX; // mengisi komponen vektor x pada variable dengan koordinat x dari mouse/pointer
			onMouseDownPosition.y = event.clientY; // mengisi komponen vektor y pada variable dengan koordinat y dari mouse/pointer

			// theta dan phi digunakan untuk rotasi page. theta dan phi sebenernya sama aja, bedanya theta buat x dan phi buat y
		}
	
		function onDocumentMouseMove( event ) {
	
			event.preventDefault();
	
			if ( isMouseDown ) { // blok fungsi yang dilakukan jika tombol mouse sedang digerakan sambil ditekan (di drag)
	
				theta = - ( ( event.clientX - onMouseDownPosition.x ) * 0.5) + onMouseDownTheta; // nilai theta berubah sebesar (jarak kita ngedrag(posisi pas kita tekan - posisi akhir pas kita seret pointernya)*0.5 + onMouseDownTheta(posisi koordinat x pas kita neken terakhir sebelum neken buat ngedrag))
				// ditambah onMouseDownTheta fungsinya untuk memberitahu komputer koordinat asal kita dan jarak kita ngedrag digunakan untuk memberitahu komputer kita mau pindah sejauh apa. dikali 0.5 supaya kita rotatenya gak terlalu jauh (kalo bingung coba aja ganti jadi 100)
				// tanda minus di depannya biar kalo kita drag ke kanan, kameranya geser ke kiri. kalo yang phi kan gak minus soalnya kalo kita drag ke atas, kameranya geraknya ke atas.
				phi = ( ( event.clientY - onMouseDownPosition.y ) * 0.5 ) + onMouseDownPhi;
	
				phi = Math.min( 180, Math.max( 0, phi ) ); // digunakan agar nilai phi tidak kurang dari 0(jika kurang, maka yang diambil adalah 0) dan tidal lebih dari 180 (jika lebih maka yang diambil adalah 180)
	
				camera.position.x = radious * Math.sin( theta * Math.PI / 360 ) * Math.cos( phi * Math.PI / 360 );
				camera.position.y = radious * Math.sin( phi * Math.PI / 360 );
				camera.position.z = radious * Math.cos( theta * Math.PI / 360 ) * Math.cos( phi * Math.PI / 360 );
				camera.updateMatrix();
	
			}
	
			mouse3D = projector.unprojectVector( new THREE.Vector3( ( event.clientX / renderer.domElement.width ) * 2 - 1, - ( event.clientY / renderer.domElement.height ) * 2 + 1, 0.5 ), camera ); // menghitung koordinat mouse berdasarkan perangkat yang digunakan
			ray.direction = mouse3D.subSelf( camera.position ).normalize(); // mengatur jarak ray dari origin berdasarkan posisi kamera yang sudah diperbaharui oleh mouse sebelumnya
	
			interact();
			render();
	
		}
	
		function onDocumentMouseUp( event ) {
	
			event.preventDefault();
	
			isMouseDown = false; // variable tombol kiri mouse diubah jadi false saat tombol mouse dilepas
	
			onMouseDownPosition.x = event.clientX - onMouseDownPosition.x; // menghitung perubahan koordinat x agar nanti bisa dibedakan niat user untuk klik atau drag
			onMouseDownPosition.y = event.clientY - onMouseDownPosition.y; // menghitung perubahan koordinat y agar nanti bisa dibedakan niat user untuk klik atau drag
	
			if ( onMouseDownPosition.length() > 5 ) { // jika panjang vektor perubahan posisinya lebih dari 5, maka tujuan user adalah untuk drag(mengubah posisi kamera), sedangkan jika kurang dari 5 maka user ingin klik saja/membuat kubus
					// notes: 5 itu sebenernya suka2 aja, boleh kita pakai angka berapapun untuk batas toleransinya
				return; // keluar dari fungsi karena ternyata user hanya ingin drag kamera saja (proses drag sudah dijalankan saat fungsi onDocumentMouseMove berjalan)
	
			}
			// script dibawah dijalankan karena ternyata user ingin mengklik/membuat kubus
			var intersect, intersects = ray.intersectScene( scene ); //variable intersects akan berisi intersect (persinggungan/perpotongan) antara ray dengan object pada scene (plane dan brush). persinggungan ray dengan scene diwakili oleh mouse karena ray.direction berisi posisi kamera yang sudah diperbaharui berdasarkan mouse.
	
			if ( intersects.length > 0 ) { // if disini digunakan apabila terdapat intersect antara ray dengan scene (contohnya kalau kita ngeklik di luar kotak, gak akan muncul apa2)
	
				intersect = intersects[ 0 ].object == brush ? intersects[ 1 ] : intersects[ 0 ]; // variable intersect akan berisi object yang sesuai dengan object brush
				
				if ( intersect ) {
	
					if ( isShiftDown ) {
	
						if ( intersect.object != plane ) { // ini sebenernya gak perlu sih soalnya sebelumnya intersect emang udah diisi sama object brush
	
							scene.removeObject( intersect.object ); // menghapus kubus karena tombol shift ditekan
	
						}
	
					} else {
	
						var position = new THREE.Vector3().add( intersect.point, intersect.object.matrixRotation.transform( intersect.face.normal.clone() ) );
	
						var voxel = new THREE.Mesh( cube, [new THREE.MeshColorFillMaterial( colors[ color ] ), densities[density], "manual"] );
						voxel.position.x = Math.floor( position.x / 50 ) * 50 + 25; // digunakan untuk menentukan koordinat dari kubus. +25 digunakan agar kubus berada di tengah (panjang, lebar, tingginya kan 50)
						voxel.position.y = Math.floor( position.y / 50 ) * 50 + 25; // nilainya dibagi 50 terus dibuletin ke bawah biar dapet koordinat yang diinginkannya. position.x,position.y,position.z itu diambil dari koordinat kursor mouse pas ngeklik soalnya
						voxel.position.z = Math.floor( position.z / 50 ) * 50 + 25;
						voxel.overdraw = true;
						scene.addObject( voxel ); // membuat object kubus kedalam scene
						koordinat_x = Math.floor( position.x / 50 ) * 50;
						koordinat_y = Math.floor( position.z / 50 ) * 50;
						koordinat_z = Math.floor( position.y / 50 ) * 50;
					}
	
				}
	
			}
	
			updateHash();
			interact();
			render();
	
		}
	
		function onDocumentMouseWheel( event ) { // fungsi yang digunakan saat roda scroll mouse digunakan
	
			radious -= event.wheelDeltaY;
	
			camera.position.x = radious * Math.sin( theta * Math.PI / 360 ) * Math.cos( phi * Math.PI / 360 );
			camera.position.y = radious * Math.sin( phi * Math.PI / 360 );
			camera.position.z = radious * Math.cos( theta * Math.PI / 360 ) * Math.cos( phi * Math.PI / 360 );
			camera.updateMatrix();
	
			interact();
			render();
	
		}
	
		function setBrushColor( value ) { // fungsi buat ngewarnain kubus
	
			color = value;
			brush.material[ 0 ].color.setHex( colors[ color ] ^ 0x4C000000 );
	
			render();
	
		}
	
		function buildFromHash() { // fungsi ini hanya akan dipanggil apabila sudah pernah ada kubus sebelumnya
	
			var path_save = window.location.pathname.substr( 9 ), // variable hash digunakan untuk mengambil string url dimulai dari setelah # (makanya substring(1)). 
			version = path_save.substr( 0, 2 ); // version dipake buat ngecek string A/ karena kalau udah pernah ada yang ngisi, di url pasti ada A/
			var data_custom = 0;
			if ( version == "A:" ) { // kondisi jika ada A/ (sudah pernah ada kubus sebelumnya)
				var current = { x: 0, y: 0, z: 0, c: 0}
				var data = decode( path_save.substr( 2 ) );
				if(data.length == 2){
					data_custom = data[1];
					data = data[0];
				}else{
					data = data[0];
				}
				var i = 0, l = data.length;
	
				while ( i < l ) {
					var code = data[ i ++ ].toString(); // mengubah data ke format string

					if ( code.charAt( 1 ) == "1" ) current.x += data[ i ++ ];
					if ( code.charAt( 2 ) == "1" ) current.y += data[ i ++ ];
					if ( code.charAt( 3 ) == "1" ) current.z += data[ i ++ ];
					if ( code.charAt( 4 ) == "1" ) current.c += data[ i ++ ];
					if ( code.charAt( 0 ) == "1" ) {
	
						var voxel = new THREE.Mesh( cube, [new THREE.MeshColorFillMaterial( colors[ current.c ] ), densities[current.c], "manual"] );
						voxel.position.x = current.x * 50 + 25;
						voxel.position.y = current.y * 50 + 25;
						voxel.position.z = current.z * 50 + 25;
						voxel.overdraw = true;
						scene.addObject( voxel );
	
					}
				}
				if(data_custom != 0){
					var jumlah = data_custom.length - 1, hitung = 0;
					while(jumlah>hitung){
						cube = new Cube( data_custom[hitung][1]-data_custom[hitung][0], data_custom[hitung][5]-data_custom[hitung][4], data_custom[hitung][3]-data_custom[hitung][2]);
						voxel = new THREE.Mesh( cube, [new THREE.MeshColorFillMaterial( colors[ current.c ] ), densities[current.c], "custom"] );
						voxel.position.x = data_custom[hitung][0]+(data_custom[hitung][1]-data_custom[hitung][0])/2;
						voxel.position.y = data_custom[hitung][4]+(data_custom[hitung][5]-data_custom[hitung][4])/2;
						voxel.position.z = data_custom[hitung][2]+(data_custom[hitung][3]-data_custom[hitung][2])/2;
						voxel.overdraw = true;
						scene.addObject( voxel );
						hitung = hitung + 1;					
						// var awal_x=data_custom[0];
						// while(awal_x<data_custom[1]){
						// 	var awal_y=data_custom[4];
						// 	while(awal_y <data_custom[5]){
						// 		var awal_z=data_custom[2];
						// 		while(awal_z<data_custom[3]){
						// 			voxel = new THREE.Mesh( cube, [new THREE.MeshColorFillMaterial( colors[ current.c ] ), densities[current.c], "manual"] );
						// 			voxel.position.x = awal_x+25;
						// 			voxel.position.y = awal_y+25;
						// 			voxel.position.z = awal_z+25;
						// 			voxel.overdraw = true;
						// 			scene.addObject( voxel );
						// 			awal_z = awal_z+ 50;
						// 		}
						// 		awal_y = awal_y+50;
						// 	}
						// 	awal_x = awal_x+50;
						// }
					}
					cube = new Cube( 50, 50, 50 );
				}	
			} else {
				var data = decode( path_save );
				data = data[0];
	
				for ( var i = 0; i < data.length; i += 4 ) {
	
					var voxel = new THREE.Mesh( cube, new THREE.MeshColorFillMaterial( colors[ data[ i + 3 ] ] ) );
					voxel.position.x = ( data[ i ] - 20 ) * 25;
					voxel.position.y = ( data[ i + 1 ] + 1 ) * 25;
					voxel.position.z = ( data[ i + 2 ] - 20 ) * 25;
					voxel.overdraw = true;
					scene.addObject( voxel );
	
				}
	
			}
	
			updateHash();
	
		}
	
		function updateHash() {
			var data = [],
			var data_custom_update = "", sementara = "",
			current = { x: 0, y: 0, z: 0, c: 0},
			last = { x: 0, y: 0, z: 0, c: 0},
			code; // pendefisian variable. code adalah variable yang nantinya diisi dengan biner
			
			for ( var i in scene.objects ) { // mengiterasi object yang ada di scene
	
				object = scene.objects[ i ];
				
				if ( object instanceof THREE.Mesh && object !== plane && object !== brush ) { // blok dijalankan jika object merupakan kubus
					if (object.material[2] == "manual"){
						current.x = ( object.position.x - 25 ) / 50; // dikurangi 25 karena object itu adanya ditengah-tengah grid. dibagi 50 biar tau dia itu posisi keberapa dari pusat
						current.y = ( object.position.y - 25 ) / 50;
						current.z = ( object.position.z - 25 ) / 50;
						current.c = colors.indexOf( object.material[ 0 ].color.hex & 0xffffff ); // mengambil warna object yang sudah ada
						current.d = densities[object.material[1]]

						code = 0;
		
						if ( current.x != last.x ) code += 1000; // x itu ditandai dengan biner ribuan/angka 1 di posisi kedua dari bilanan biner
						if ( current.y != last.y ) code += 100; // y itu ditandai dengan biner ratusan/angka 1 diposisi ketiga dari bilanan biner
						if ( current.z != last.z ) code += 10; // z itu ditandai dengan biner puluhan/angka 1 diposisi keempat dari bilanan biner
						if ( current.c != last.c ) code += 1;// c itu ditandai dengan biner satuan/angka 1 diposisi kelima dari bilanan biner

						code += 10000; // ditambah 10000 biar pas iterasi ditandai bahwa awal dari box baru
						data.push( code ); // nilai kode dikonversi dari biner ke desimal
						data.push(";")

						if ( current.x != last.x ) {
		
							data.push( current.x - last.x ); // plus 32 disini sebenernya bisa diganti berapapun. 32 menandakan perubahan koordinat dari kotak pertama ke kedua ke sumbu negatif maksimumnya = 32. kalau lebih dari 32 akan negatif.
							// dan juga menandakan perubahan koordinat dari kotak pertama ke kedua ke sumbu positif maksimumnya 31. hal ini terbatas karena string yang ada di encode sama decode jumlahnya cuma 64. jadi kode stringnya dipake buat 32 ke kanan, 31 ke kiri, dan 1 buat 0(saat tidak ada perubahan).
							data.push(";")
							last.x = current.x;
		
						}
		
						if ( current.y != last.y ) {
		
							data.push( current.y - last.y );
							data.push(";")
							last.y = current.y;
		
						}
		
						if ( current.z != last.z ) {
		
							data.push( current.z - last.z );
							data.push(";")
							last.z = current.z;
		
						}
		
						if ( current.c != last.c ) {
		
							data.push( current.c - last.c );
							data.push(";")
							last.c = current.c;
							last.d = current.d;
		
						}
					}else{
						var path_save = window.location.pathname.substr( 9 );
						var data_update = decode( path_save.substr( 2 ) );
						data_custom_update = data_update[1];
						data_custom_update.forEach(function (v) {
							v.forEach(function (i) {
								sementara = sementara+i.toString();
							})
						})

					}
	
				}
	
			}
			data = encode( data );
			densities_send = encode(densities)
			save_data = "A:" + data +"["+densities_send+data_custom_update;
	
		}
	
		function offsetScene( x, z ) {
	
			var offset = new THREE.Vector3( x, 0, z ).multiplyScalar( 50 );
	
			for ( var i in scene.objects ) {
	
				object = scene.objects[ i ];
	
				if ( object instanceof THREE.Mesh && object !== plane && object !== brush ) {
	
					object.position.addSelf( offset );
	
				}
	
			}
	
			updateHash();
			interact();
			render();
	
		}
	
		function interact() {
	
			if ( objectHovered ) {
	
				objectHovered.material[ 0 ].color.a = 1;
				objectHovered.material[ 0 ].color.updateStyleString();
				objectHovered = null;
	
			}
	
			var position, intersect, intersects = ray.intersectScene( scene );
	
			if ( intersects.length > 0 ) {
	
				intersect = intersects[ 0 ].object != brush ? intersects[ 0 ] : intersects[ 1 ];
	
				if ( intersect ) {
	
					if ( isShiftDown ) {
	
						if ( intersect.object != plane ) {
	
							objectHovered = intersect.object;
							objectHovered.material[ 0 ].color.a = 0.5;
							objectHovered.material[ 0 ].color.updateStyleString();
	
							return;
	
						}
	
					} else {
	
						position = new THREE.Vector3().add( intersect.point, intersect.object.matrixRotation.transform( intersect.face.normal.clone() ) );
	
						brush.position.x = Math.floor( position.x / 50 ) * 50 + 25;
						brush.position.y = Math.floor( position.y / 50 ) * 50 + 25;
						brush.position.z = Math.floor( position.z / 50 ) * 50 + 25;
	
						return;
	
					}
	
				}
	
			}
	
			brush.position.y = 25;
	
		}
	
		function render() { // fungsi untuk merender
	
			renderer.render( scene, camera );
	
		}

		function save_data_function() { 
			updateHash();
			if (save_data.substr(2,1) !== "[" ){
				window.location.href="/model3dnew/"+save_data+"/";
			}
			else{
				alert("Maaf, Anda belum membuat box apapun!");
			}
		}

		function custom_box_function() {
			updateHash();
			window.location.href = "/custom/"+save_data+"/";
		}
	
		function download() { // fungsi untuk save data
			linesMaterial.color.setRGBA( 0, 0, 0, 0 );
			brush.position.y = 25;
			render();
			
			var link = document.getElementById('link');
			link.setAttribute('download', 'model3d.png');
			link.setAttribute('href', renderer.domElement.toDataURL("image/png").replace("image/png", "image/octet-stream"));
			link.click();
	
			linesMaterial.color.setRGBA( 0, 0, 0, 0.2 );
			render();
	
		}
	
		function clear() { // fungsi untuk menghapus semua box
	
			if ( !confirm( 'Are you sure?' ) ) {
	
				return
	
			}
	
			window.location.hash = "";
	
			var i = 0;
	
			while ( i < scene.objects.length ) {
	
				object = scene.objects[ i ];
	
				if ( object instanceof THREE.Mesh && object !== plane && object !== brush ) {
	
					scene.removeObject( object );
					continue;
				}
	
				i ++;
			}
	
			updateHash();
			render();
	
		}
	
		function decode( string ) { // ngubah string ke data array
	
			var output = [];
			var output_custom = [], string_custom_split = [], sementara = [];
			string_2 = string.split("[")[0];
			if(string.split("[").length == 3){
				string_custom = string.split("[")[2];
				string_2.split(";").forEach(
					function ( v ) {
						function checkindex(i) {
						return i == v;
					}
					if(alf_code.includes(v)){
						v = bin_code[alf_code.findIndex(checkindex)];
					}
						output.push(parseInt(v)); 
					}
				);
				string_custom.split("]").forEach(function (v) {string_custom_split.push(v.split(":"))});
				string_custom_split.forEach(function (v) {
					v.forEach(function (i) {
						sementara.push(parseInt(i));
					})
					output_custom.push(sementara);
					sementara = [];
				})
				return [output,output_custom];
			}else{
				string_2.split(";").forEach( function ( v ) { output.push(parseInt(v)); } );
				return [output];
			}
	
		}
	
		function encode( array ) { // ngubah data biner ke string
	
			var output = "";
			array.forEach(
			function ( v ) {
				function checkindex(i) {
					return i == v.toString();
				}
				if(v.toString().length == 5){
					v = alf_code[bin_code.findIndex(checkindex)];
				}
				output += v.toString(); 
			}
			);
			return output;
	
		}
	
	</script>
</div>


{% endblock content %}
